//    .         .
var waitQueue = new Array(); 

//  .   ,          .
var freeItems = new Object(); 

//     - push  pop. pop     , 
//  ,        .
freeItems.array = new Array();
freeItems.weightSum = 0;
freeItems.push = function(freeItem) {
    freeItems.array.push(freeItem);
    freeItems.weightSum += freeItem.weight;
};

freeItems.pop = function() {
   var rnd = Math.random() * freeItems.weightSum;
   var i = -1;
   while (rnd >= 0) {
      i++;
      rnd -= freeItems.array[i].weight;
   }
   var output = freeItems.array.splice(i,1)[0];
   freeItems.weightSum -= output.weight;
   return output;
};

//   .
var deletedItems=new Array();

function deleteItem(item) {
   item.state = "deleted";
   deletedItems.push(item);
}


// 
var timeAlerts=new Array();

function addTimeAlert(time, item) {
    item.alertionTime = time;
    var delay = time - ((new Date()).getTime());
    if (delay > 0) {
        timeAlerts.push(item);
        timeAlerts.sort(function compareWeights(a, b) {return a.alertionTime - b.alertionTime});
        if (item.crash == true) {
            window.setTimeout('waitQueue.unshift(timeAlerts.pop());', delay);
        } else {
            window.setTimeout('waitQueue.push(timeAlerts.pop());', delay);
        }
    }
}

function delayItem(item) {
   item.state = "delayed";
   addTimeAlert(((new Date()).getTime()) + 1800000, item);
}


//alert('t-itemBase loaded');
