// main menu

var strongPause = false;

var systemActions = new Array();

function initSystemActions() {
    var pauseAction = new action(
        'pause',
        function() {
            scrollPause = true; 
            strongPause = true;
            systemActions[0] = unPauseAction;
        }
    );
    
    var unPauseAction = new action(
        'Unpause',
        function() {
            strongPause = false;
            scrollPause = false;
            systemActions[0] = pauseAction;
        }
    );


    systemActions[0] = pauseAction;
    systemActions[1] = new action(
        "RSS feeds properties", 
        function() {
            showFeedProps();
        }
    );
}

// Article actions

var articleActions = new Array();

function initArticleActions() {
    articleActions[0] = new action(
        'Open', 
        function() { 
            open(items[contextNode.item.id].link, '_new');
        }
    );
    articleActions[1] = new actionWithControl(
        'Delete', 
        function() { 
            deleteItem(contextNode.item); 
            collapseNode(contextNode);
        }, 
        "images/delete.gif"
    );
    articleActions[2] = new actionWithControl(
        'Delay', 
        function() { 
            delayItem(contextNode.item);
            collapseNode(contextNode);
        },
        "images/clock.gif"
    );
}

// InfoPeace actions

var infoPeaceActions = new Array();

function initInfoPeaceActions() {
    infoPeaceActions[0] = new actionWithControl(
        'Delete', 
        function() { 
            deleteItem(contextNode.item); 
            collapseNode(contextNode);
        }, 
        "images/delete.gif"
    );
    infoPeaceActions[1] = new actionWithControl(
        'Delay', 
        function() { 
            delayItem(contextNode.item);
            collapseNode(contextNode);
        },
        "images/clock.gif"
    );
}

function initActions() {
    initSystemActions();
    initArticleActions();
    initInfoPeaceActions();
}


//alert('t-actions loaded');