var contextNode = null;

function actionWithControl(name, func, img) {
   this.name = name;
   this.func = func;
   this.img = img;
}

function action(name, func) {
   this.name = name;
   this.func = func;
   this.img = null;
}


//context menu
var actPopup = window.createPopup();

actPopup.document.body.style.backgroundColor = "rgb(220,220,220)";
actPopup.document.body.style.border = "solid black 1px";
actPopup.document.body.style.margin = "0px";
actPopup.document.body.style.padding = "2px";

var rotationI=0;
var currentMenu=null;

function showContextMenu(actions) {
    rotationI = 0;
    currentMenu = actions;
    fillContextMenu();

    actPopup.document.body.oncontextmenu = function() {
        rotateContextMenu();
        contextMenuPostCorrection();
    };

    document.getElementById('trybox').innerHTML = actPopup.document.body.innerHTML;

    var width = document.getElementById('popupInnerContainer').offsetWidth+6;
    var height = document.getElementById('popupInnerContainer').offsetHeight+6;

    if (mouseY - height * 1.2 > 0) {
        actPopup.show(
            mouseX - width / 2, 
            mouseY - height + 3 + document.getElementById('butt' + (actions.length - 1)).offsetHeight / 2, 
            width, 
            height
        );
    } else {
       rotateContextMenu();
       actPopup.show(
        mouseX - width / 2, 
        mouseY - 3 - document.getElementById('butt0').offsetHeight / 2, width, height);
    }

    document.getElementById('trybox').innerHTML = "";
    contextMenuPostCorrection()
}

function rotateContextMenu() {
   rotationI++;
   fillContextMenu();
}

function fillContextMenu() {
    actPopup.document.body.innerHTML="<table id='popupInnerContainer' cellpadding=0 cellspacing=0><tbody id='insertField'></tbody></table>";
    for (var i = currentMenu.length - 1; i >= 0; i--) {
       var tr = actPopup.document.createElement('tr');
       var td = actPopup.document.createElement('td');
       var butt = actPopup.document.createElement('button');
       butt.id = 'butt'+i;
       butt.innerHTML = currentMenu[(i + rotationI) % currentMenu.length].name;       
       butt.onclick = new Function(
           "currentMenu["+ ((i + rotationI) % currentMenu.length) +"].func();" +
           "actPopup.hide();"
       );

       td.appendChild(butt);
       tr.appendChild(td);
       actPopup.document.getElementById('insertField').appendChild(tr);
    }
}

function contextMenuPostCorrection() {
   var maxWidth = 0;
   for (var i = 0; i < currentMenu.length; i++) {
      maxWidth=Math.max(maxWidth, actPopup.document.getElementById('butt'+i).offsetWidth);
   }
   for (var i = 0; i < currentMenu.length; i++) {
      actPopup.document.getElementById('butt' + i).style.pixelWidth = maxWidth;
   }
}

//alert('t-contextMenu loaded');