PROTECT_INTERVAL = 333;
var popuptimer = null;

var nodes = new Array();

function createNode(newItem) {
    // Creating event container
    var containerNode = document.createElement('div');

        ida = pack(nodes, containerNode);
        containerNode.ida = ida;
        containerNode.item = newItem;

        containerNode.className = 'container';
        containerNode.style.pixelLeft = document.body.offsetWidth;

        containerNode.id = 'node' + newItem.id;
        containerNode.onmouseenter = new Function(
            "nodes["+ ida +"].style.borderColor = 'rgb(230,230,230)';" +
            "popuptimer = window.setTimeout('CmdShowDescrPopup(items["+ newItem.id +"])', PROTECT_INTERVAL);"
        );
        containerNode.onmouseleave = new Function(
            "if (popuptimer) {"+
                "clearTimeout(popuptimer);"+
                "popuptimer = null;"+
            "}"+
            "CmdHideDescrPopup();" + 
            "nodes["+ ida +"].style.borderColor = 'rgb(255,255,255)';"
        );
        containerNode.onclick = new Function(
            "if (popuptimer) {"+
                "clearTimeout(popuptimer);"+
                "popuptimer = null;"+
            "}"+
            "contextNode = nodes["+ ida +"];" +
            "showContextMenu(items["+ newItem.id +"].actions);" 
        );
        containerNode.ondblclick = new Function(
            "if (popuptimer) {"+
                "clearTimeout(popuptimer);"+
                "popuptimer = null;"+
            "}"+
            "contextNode = nodes["+ ida +"];" +
            "items["+ newItem.id +"].actions[0].func();" 
        );
    
        // Creating type icon
        var typeIconNode = document.createElement('img');
            typeIconNode.className = 'icon';
            if (newItem.type == 'mail') {
                typeIconNode.setAttribute('src', 'images/mail.gif');
            } else if (newItem.type == 'article') {
                typeIconNode.setAttribute('src', 'images/web.gif');
            } else if (newItem.type == 'infoPeace') {
                typeIconNode.setAttribute('src', 'images/info.gif');
            }

        containerNode.appendChild(typeIconNode);
    
        // Creating delayed flag icon
        if (newItem.state == 'delayed') {
            var delayedIcon = document.createElement('img');
                delayedIcon.className = 'icon';
                delayedIcon.src = 'images/clock.gif';
            containerNode.appendChild(delayedIcon);
        }


        // Creating title
        var titleNode = document.createElement('span');
            titleNode.className = 'title';
            var titleText = null;
            if (newItem.title != null) {
                titleText = document.createTextNode(newItem.source + ': ');
            } else {
                titleText = document.createTextNode(newItem.source);
            }
            titleNode.appendChild(titleText);
        containerNode.appendChild(titleNode);


        // Creating content
        if (newItem.title != null) {
           contentNode = document.createElement('span');
               contentNode.className = 'content';
               var contentText = document.createTextNode(newItem.title);
               contentNode.appendChild(contentText);
            containerNode.appendChild(contentNode);
        }

        // Creating controls
        for ( var i = 0; i < newItem.actions.length; i++ ) if (newItem.actions[i].img) {
            var ButtonNode = document.createElement('img');
                ButtonNode.className = 'control';
                ButtonNode.src = newItem.actions[i].img;
                ButtonNode.onclick = new Function(
                   "contextNode = nodes["+ ida +"];" +
                   "event.cancelBubble=true;" +
                   "items["+ newItem.id +"].actions["+ i +"].func();"
                );
            containerNode.appendChild(ButtonNode);
        }

        // Creating space after the item
        afterSpace = document.createElement('span');
            afterSpace.className = 'afterspace';
        containerNode.appendChild(afterSpace);
    
    ticker.appendChild(containerNode);
    return containerNode;
}


function removeNode(node) {
    if (node) {
        ticker.removeChild(node);
    }
    nodes[node.ida] = undefined;
}


//alert('t-nodes loaded');